VERSION 5.00
Begin VB.Form frmMortgageAnalyzer 
   Caption         =   "Mortgage Analyzer"
   ClientHeight    =   6216
   ClientLeft      =   3048
   ClientTop       =   1356
   ClientWidth     =   6564
   LinkTopic       =   "Form1"
   ScaleHeight     =   6216
   ScaleWidth      =   6564
   Begin VB.ComboBox cboTerm 
      Height          =   288
      ItemData        =   "frmMortgageAnalyzer.frx":0000
      Left            =   3000
      List            =   "frmMortgageAnalyzer.frx":0016
      TabIndex        =   9
      Top             =   3840
      Width           =   1332
   End
   Begin VB.ComboBox cboInterestRate 
      Height          =   288
      ItemData        =   "frmMortgageAnalyzer.frx":0031
      Left            =   3000
      List            =   "frmMortgageAnalyzer.frx":004A
      TabIndex        =   7
      Top             =   3480
      Width           =   1332
   End
   Begin VB.CommandButton cmdCalculate 
      Caption         =   "&Calculate"
      Height          =   372
      Left            =   240
      TabIndex        =   10
      Top             =   4920
      Width           =   1572
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "&Print"
      Height          =   372
      Left            =   5280
      TabIndex        =   12
      Top             =   5040
      Width           =   972
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "&Done"
      Height          =   372
      Left            =   5280
      TabIndex        =   13
      Top             =   5520
      Width           =   972
   End
   Begin VB.TextBox txtPrincipal 
      Height          =   288
      Left            =   3000
      TabIndex        =   5
      Top             =   3120
      Width           =   1332
   End
   Begin VB.ListBox lstWhatToCalculate 
      Height          =   624
      ItemData        =   "frmMortgageAnalyzer.frx":0071
      Left            =   2640
      List            =   "frmMortgageAnalyzer.frx":007B
      TabIndex        =   2
      Top             =   1920
      Width           =   3252
   End
   Begin VB.Label lblIvyRealestate 
      Caption         =   "Ivy Real Estate Mortgage Analyzer"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   13.8
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      Height          =   732
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   2532
   End
   Begin VB.Label lblTerm 
      Caption         =   "&Term (years):"
      Height          =   252
      Left            =   600
      TabIndex        =   8
      Top             =   3840
      Width           =   1452
   End
   Begin VB.Label lblRate 
      Caption         =   "Annual interest &rate (%):"
      Height          =   252
      Left            =   600
      TabIndex        =   6
      Top             =   3480
      Width           =   2052
   End
   Begin VB.Label lblAnswer 
      Height          =   372
      Left            =   240
      TabIndex        =   11
      Top             =   5520
      Width           =   4572
   End
   Begin VB.Label lblEnterInformation 
      Caption         =   "Enter the following information:"
      Height          =   252
      Left            =   240
      TabIndex        =   3
      Top             =   2760
      Width           =   2412
   End
   Begin VB.Image imgIvy 
      Height          =   1464
      Left            =   2400
      Picture         =   "frmMortgageAnalyzer.frx":00C8
      Stretch         =   -1  'True
      Top             =   120
      Width           =   1584
   End
   Begin VB.Label lblPayments 
      Height          =   252
      Left            =   600
      TabIndex        =   4
      Top             =   3120
      Width           =   2292
   End
   Begin VB.Label lblWhatToCalculate 
      Caption         =   "&What do you want to calculate:"
      Height          =   252
      Left            =   240
      TabIndex        =   1
      Top             =   1920
      Width           =   2292
   End
End
Attribute VB_Name = "frmMortgageAnalyzer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 8 Mortgage Analyzer Case Study
'   3/99

Option Explicit

Private Sub Form_Load()
    Call ClearForm
End Sub

Private Sub lstWhatToCalculate_Click()
    lblEnterInformation.Visible = True
    
    lblRate.Visible = True
    cboInterestRate.Visible = True
    cboInterestRate.Text = 7
    
    lblTerm.Visible = True
    cboTerm.Visible = True
    cboTerm.Text = 15
    
    If lstWhatToCalculate.Text = "The monthly payments of a mortgage" Then
        lblPayments.Caption = "&Loan amount ($):"
    Else
        lblPayments.Caption = "&Maximum monthly payments ($):"
    End If
    
    lblPayments.Visible = True
    txtPrincipal.Visible = True
    lblAnswer.Caption = ""
End Sub

Private Sub cboInterestRate_Click()             'user clicked on new value in the combo box
    Call CheckValues
End Sub

Private Sub cboTerm_Click()                         'user clicked on new value in the combo box
    Call CheckValues
End Sub

Private Sub cboInterestRate_Change()        'user typed a value in the combo box
    Call CheckValues
End Sub

Private Sub cboTerm_Change()                        'user typed a value in the combo box
    Call CheckValues
End Sub

Private Sub txtPrincipal_Change()                   'user types a value in the text box
    Call CheckValues
End Sub

'***********************************************************
'   Displays the Calculate command button if combo boxes
'   and text boxes contain values greater than 0
'
'   post: Calculate command button displayed if rate, term
'   and payment values entered by user are greater than 0
'***********************************************************
Sub CheckValues()
    If IsNumeric(cboInterestRate.Text) And IsNumeric(cboTerm.Text) _
        And IsNumeric(txtPrincipal.Text) Then
        cmdCalculate.Visible = True
    Else
        cmdCalculate.Visible = False
    End If
    lblAnswer.Caption = ""
End Sub

Private Sub cmdCalculate_Click()
    Dim dblInterestRate As Double, intTerm As Integer, curPrincipal As Currency
    Dim curAnswer As Currency
    
    dblInterestRate = cboInterestRate.Text / 100
    intTerm = cboTerm.Text
    curPrincipal = txtPrincipal.Text
   
    If lstWhatToCalculate.Text = "The monthly payments of a mortgage" Then
        curAnswer = Pmt(dblInterestRate / 12, intTerm * 12, -curPrincipal)
        lblAnswer.Caption = "The monthly payments would be " _
            & Format(curAnswer, "Currency")
    Else
        curAnswer = PV(dblInterestRate / 12, intTerm * 12, -curPrincipal)
        lblAnswer.Caption = "You can afford a house that is less than " _
            & Format(curAnswer, "Currency")
    End If
    lblAnswer.Visible = True
End Sub

Private Sub cmdPrint_Click()
    Me.PrintForm
    
    lstWhatToCalculate.Text = ""
    txtPrincipal.Text = ""
    
    Call ClearForm
End Sub

Sub ClearForm()
    lblEnterInformation.Visible = False
    lblRate.Visible = False
    cboInterestRate.Visible = False
    lblTerm.Visible = False
    cboTerm.Visible = False
    lblPayments.Visible = False
    txtPrincipal.Visible = False
    cmdCalculate.Visible = False
    lblAnswer.Caption = ""
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

