VERSION 5.00
Begin VB.Form frmDiceRolls 
   Caption         =   "Dice Rolls"
   ClientHeight    =   2604
   ClientLeft      =   3480
   ClientTop       =   2388
   ClientWidth     =   3300
   LinkTopic       =   "Form1"
   ScaleHeight     =   2604
   ScaleWidth      =   3300
   Begin VB.ListBox lstOutcome 
      Height          =   1584
      ItemData        =   "frmDiceRolls.frx":0000
      Left            =   240
      List            =   "frmDiceRolls.frx":0002
      TabIndex        =   3
      Top             =   720
      Width           =   1452
   End
   Begin VB.CommandButton cmdRollDice 
      Caption         =   "Roll Dice"
      Height          =   372
      Left            =   2040
      TabIndex        =   2
      Top             =   1320
      Width           =   972
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   2040
      TabIndex        =   4
      Top             =   1920
      Width           =   972
   End
   Begin VB.TextBox txtNumRolls 
      Height          =   288
      Left            =   1800
      TabIndex        =   1
      Top             =   240
      Width           =   612
   End
   Begin VB.Label lblNumofRolls 
      Caption         =   "Enter number of rolls:"
      Height          =   252
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1572
   End
End
Attribute VB_Name = "frmDiceRolls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 9 Dice Rolls
'   3/99

Option Explicit

Private Sub Form_Load()
    Randomize
End Sub

Private Sub cmdRollDice_Click()
    Dim intNumRolls As Integer
    Dim intCounts(2 To 12) As Integer       ' lowest roll is 2, highest is 12

    intNumRolls = txtNumRolls.Text
    Call CountTrials(intNumRolls, intCounts())
    Call DisplayCounts(intCounts(), lstOutcome)
End Sub

Private Sub txtNumRolls_Change()
    lstOutcome.Clear
End Sub

'****************************************************************************
' Simulates intNumRolls rolls of two dice and stores the
' counts of each outcome in intCounts()
'
' pre: intCount() lower bound is 2, upper bound is 12
' post: intNumRolls dice rolls simulated. Counts of
' intNumRolls simulated dice rolls stored in intCounts()
'****************************************************************************
Sub CountTrials(ByVal intNumRolls As Integer, ByRef intCounts() As Integer)
    Dim intRoll As Integer, intRollOutcome As Integer

    For intRoll = 1 To intNumRolls
        intRollOutcome = Int(6 * Rnd + 1) + Int(6 * Rnd + 1)
        intCounts(intRollOutcome) = intCounts(intRollOutcome) + 1
    Next intRoll
End Sub

'*************************************************************************
' Displays the contents of intCounts() in a list box
'
' post: Elements of intCounts() displayed in a list box
'*************************************************************************
Sub DisplayCounts(ByRef intCounts() As Integer, ByRef lstList As ListBox)
    Dim intRollOutcome As Integer

    For intRollOutcome = LBound(intCounts) To UBound(intCounts)
        lstList.AddItem intRollOutcome & vbTab & intCounts(intRollOutcome)
    Next intRollOutcome
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub
