VERSION 5.00
Begin VB.Form frmDynamicArray 
   Caption         =   "Dynamic Array Demo"
   ClientHeight    =   2976
   ClientLeft      =   2448
   ClientTop       =   2052
   ClientWidth     =   4872
   LinkTopic       =   "Form1"
   ScaleHeight     =   2976
   ScaleWidth      =   4872
   Begin VB.CommandButton cmdProcess 
      Caption         =   "Process"
      Height          =   372
      Left            =   3480
      TabIndex        =   6
      Top             =   1680
      Width           =   1212
   End
   Begin VB.TextBox txtNumEntered 
      Height          =   288
      Left            =   2880
      TabIndex        =   1
      Top             =   120
      Width           =   492
   End
   Begin VB.Frame fraAction 
      Caption         =   "Action"
      Height          =   612
      Left            =   1800
      TabIndex        =   2
      Top             =   600
      Width           =   2892
      Begin VB.OptionButton optFind 
         Caption         =   "Find"
         Height          =   252
         Left            =   2040
         TabIndex        =   5
         Top             =   240
         Width           =   732
      End
      Begin VB.OptionButton optRemove 
         Caption         =   "Remove"
         Height          =   252
         Left            =   960
         TabIndex        =   4
         Top             =   240
         Width           =   972
      End
      Begin VB.OptionButton optAdd 
         Caption         =   "Add"
         Height          =   252
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   732
      End
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   3480
      TabIndex        =   8
      Top             =   2280
      Width           =   1212
   End
   Begin VB.ListBox lstArrayElements 
      Height          =   2544
      ItemData        =   "frmDynamicArrayDemo.frx":0000
      Left            =   120
      List            =   "frmDynamicArrayDemo.frx":0002
      TabIndex        =   7
      Top             =   120
      Width           =   1452
   End
   Begin VB.Label lblEnterValue 
      Caption         =   "Enter value:"
      Height          =   252
      Left            =   1800
      TabIndex        =   0
      Top             =   120
      Width           =   972
   End
End
Attribute VB_Name = "frmDynamicArray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 9 Dynamic Array Demo
'   3/99

Option Explicit

Private Sub Form_Load()
    Randomize
    optAdd.Value = True
    optRemove.Value = False
    optFind.Value = False
End Sub

Private Sub cmdProcess_Click()
    Static intDataArray() As Integer            ' Declare dynamic array
    Static intNumDataItems As Integer   ' Number of items in intDataArray
    Dim intNumEntered As Integer
    Dim intIndex As Integer

    intNumEntered = txtNumEntered.Text
    If optAdd.Value Then
        Call AddItem(intDataArray(), intNumDataItems, intNumEntered)
        Call DisplayData(intDataArray(), intNumDataItems, lstArrayElements)
    ElseIf optRemove.Value And intNumDataItems > 0 Then
        Call RemoveItem(intDataArray(), intNumDataItems, intNumEntered)
        Call DisplayData(intDataArray(), intNumDataItems, lstArrayElements)
    ElseIf optFind.Value And intNumDataItems > 0 Then
        intIndex = FindItemIndex(intDataArray(), intNumEntered)
        lstArrayElements.AddItem "Item at index " & intIndex
    End If
End Sub

'*******************************************************************
' Increases size of intDataArray() by 1, increments intNumDataItems
' by 1, and adds intNumToAdd as the last element of the array
'
' pre: intDataArray() lower bound is 0 if intDataArray() has one or
' more elements
' post: intDataArray() increased by 1, intNumDataItems incremented
' by 1, and intNumToAdd last element of array
'*******************************************************************
Sub AddItem(ByRef intDataArray() As Integer, _
ByRef intNumDataItems As Integer, ByVal intNumToAdd As Integer)
    If intNumDataItems = 0 Then
        ReDim intDataArray(intNumDataItems)     ' One element with Index 0
    Else
        ReDim Preserve intDataArray(intNumDataItems)
    End If
    intDataArray(intNumDataItems) = intNumToAdd
    intNumDataItems = intNumDataItems + 1
End Sub

'*******************************************************************************
' Decreases size of intDataArray() by 1, decrement intNumDataItems by 1,
' removes first occurence of intNumToRemove from intDataArray() if found
'
' pre: intNumDataItems > 0
' post: intDataArray() decreased by 1, intNumDataItems decremented by 1,
' intNumToRemove deleted from array, if found
'*******************************************************************************
Sub RemoveItem(ByRef intDataArray() As Integer, _
ByRef intNumDataItems As Integer, ByVal intNumToRemove As Integer)
    Dim intItemIndex As Integer, intIndex As Integer

    intItemIndex = FindItemIndex(intDataArray(), intNumToRemove)
    If intItemIndex > -1 Then                           ' fill spot of removed item
        For intIndex = intItemIndex To (UBound(intDataArray) - 1)
            intDataArray(intIndex) = intDataArray(intIndex + 1)
        Next intIndex
        intNumDataItems = intNumDataItems - 1   ' decrement intNumDataItems
        If intNumDataItems > 0 Then             ' resize array
            ReDim Preserve intDataArray(intNumDataItems - 1)
        End If
    End If
End Sub

'*************************************************************************
' Returns the index of the first occurrence of intSearchItem in
' intDataArray() or -1 if intSearchItem not found
'
' pre: intDataArray() has at least one element
' post: Index of the first occurrence of intSearchItem returned, or
' -1 returned if intSearchItem not found
'*************************************************************************
Function FindItemIndex(ByRef intDataArray() As Integer, _
ByVal intSearchItem As Integer) As Integer
    Dim intIndex As Integer

    intIndex = LBound(intDataArray)
    Do While (intDataArray(intIndex) <> intSearchItem) _
        And (intIndex < UBound(intDataArray))
        intIndex = intIndex + 1
    Loop
    If intDataArray(intIndex) = intSearchItem Then
        FindItemIndex = intIndex            ' Item found
    Else
        FindItemIndex = -1                  ' Item not found
    End If
End Function

'********************************************************************************
' Clears list box and then displays the contents of intDataArray() in a list box
'
' post: list box cleared of any previous items. intDataArray() elements
' displayed in a list box
'********************************************************************************
Sub DisplayData(ByRef intDataArray() As Integer, _
ByVal intNumDataItems As Integer, ByRef lstList As ListBox)
    Dim intIndex As Integer

    lstList.Clear
    If intNumDataItems > 0 Then
        For intIndex = LBound(intDataArray) To UBound(intDataArray)
            lstList.AddItem intIndex & vbTab & intDataArray(intIndex)
        Next intIndex
    End If
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub


