VERSION 5.00
Begin VB.Form frmLetterOccurrences 
   Caption         =   "Letter Occurrences"
   ClientHeight    =   2940
   ClientLeft      =   3132
   ClientTop       =   2388
   ClientWidth     =   3600
   LinkTopic       =   "Form1"
   ScaleHeight     =   2940
   ScaleWidth      =   3600
   Begin VB.ListBox lstOutcome 
      Height          =   1584
      ItemData        =   "frmLetterOccurrences.frx":0000
      Left            =   240
      List            =   "frmLetterOccurrences.frx":0002
      TabIndex        =   3
      Top             =   1080
      Width           =   1452
   End
   Begin VB.CommandButton cmdCountLetters 
      Caption         =   "Count Letters"
      Height          =   372
      Left            =   2040
      TabIndex        =   2
      Top             =   1680
      Width           =   1332
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   2040
      TabIndex        =   4
      Top             =   2280
      Width           =   1332
   End
   Begin VB.TextBox txtString 
      Height          =   288
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   3012
   End
   Begin VB.Label lblString 
      Caption         =   "Enter a word or phrase:"
      Height          =   252
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1932
   End
End
Attribute VB_Name = "frmLetterOccurrences"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 9 Letter Occurrences
'   3/99

Private Sub Form_Load()
    Randomize
End Sub

Private Sub cmdCountLetters_Click()
    Dim strPhrase As String
    ' 65 is ASCII code for A, 90 is ASCII code for Z
    Dim intLetterCounts(65 To 90) As Integer

    strPhrase = txtString.Text
    Call CountLetters(strPhrase, intLetterCounts())
    Call DisplayCounts(intLetterCounts(), lstOutcome)
End Sub

Private Sub txtString_Change()
    lstOutcome.Clear
End Sub

'**************************************************************************************
' Counts the occurrences of letters a through z, regardless of case, in strPhrase
'
' pre: intLetterCounts() has 26 elements with 65 lower bound and 90 upper bound
' post: intLetterCounts() contains the counts of the
' occurrences of letters a through z and A through Z in strPhrase
'**************************************************************************************
Sub CountLetters(ByVal strPhrase As String, ByRef intLetterCounts() As Integer)
    Dim intCharacter As Integer
    Dim strUppercaseLetter As String

    For intCharacter = 1 To Len(strPhrase)
        strUppercaseLetter = UCase(Mid(strPhrase, intCharacter, 1))
        If strUppercaseLetter >= "A" And strUppercaseLetter <= "Z" Then
            intLetterCounts(Asc(strUppercaseLetter)) = _
                intLetterCounts(Asc(strUppercaseLetter)) + 1
        End If
    Next intCharacter
End Sub

'****************************************************************************************
' Displays the contents of intLetterCounts() in a list box
'
' post: Elements of intLetterCounts() displayed in a list box
'****************************************************************************************
Sub DisplayCounts(ByRef intLetterCounts() As Integer, ByRef lstList As ListBox)
    Dim intLetterCount As Integer

    For intLetterCount = LBound(intLetterCounts) To UBound(intLetterCounts)
        lstList.AddItem Chr(intLetterCount) & vbTab & intLetterCounts(intLetterCount)
    Next intLetterCount
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

