VERSION 5.00
Begin VB.Form frmBinarySearch 
   Caption         =   "Binary Search"
   ClientHeight    =   2976
   ClientLeft      =   2796
   ClientTop       =   2736
   ClientWidth     =   4644
   LinkTopic       =   "Form1"
   ScaleHeight     =   2976
   ScaleWidth      =   4644
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Height          =   372
      Left            =   3360
      TabIndex        =   4
      Top             =   1920
      Width           =   1092
   End
   Begin VB.TextBox txtNumToFind 
      Height          =   288
      Left            =   3480
      TabIndex        =   1
      Top             =   240
      Width           =   492
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   3360
      TabIndex        =   5
      Top             =   2400
      Width           =   1092
   End
   Begin VB.ListBox lstArrayElements 
      Height          =   2544
      ItemData        =   "frmBinarySearch.frx":0000
      Left            =   120
      List            =   "frmBinarySearch.frx":0002
      TabIndex        =   2
      Top             =   240
      Width           =   1452
   End
   Begin VB.Label lblFoundMessage 
      Height          =   372
      Left            =   1800
      TabIndex        =   3
      Top             =   840
      Width           =   2292
   End
   Begin VB.Label lblEnterNumToFind 
      Caption         =   "Enter number to find:"
      Height          =   252
      Left            =   1800
      TabIndex        =   0
      Top             =   240
      Width           =   1572
   End
End
Attribute VB_Name = "frmBinarySearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 13 Binary Search
'   3/99

Option Explicit

Private Const intMaxNumber As Integer = 200
Private Const intNumElements As Integer = 50

Dim intDataArray() As Integer

Private Sub Form_Load()
    Randomize
    ' Generate array of random numbers
    Call GenerateSortedArray(intDataArray(), intNumElements)

    ' Display sorted array in list box
    lstArrayElements.AddItem "Sorted array:"        ' Title
    Call DisplayData(intDataArray(), lstArrayElements)
End Sub

'*****************************************************************
' Fills intArray() with intNumElements random integers ranging
' from 1 to intMaxNumber
'
' pre: Randomize called
' post: intArray() contains sorted intNumElements random integers
' ranging from 1 to intMaxNumber
'*****************************************************************
Sub GenerateSortedArray(ByRef intArray() As Integer, _
ByVal intNumElements As Integer)
    Dim intIndex As Integer

    ReDim intArray(intNumElements - 1)

    For intIndex = LBound(intArray) To UBound(intArray)
        intArray(intIndex) = Int(intMaxNumber * Rnd + 1)
    Next intIndex

    Call InsertionSort(intArray())      ' Sort array
End Sub

'*************************************************************
' Displays the contents of intArray() in a list box
'
' pre: intArray() contains at least one element
' post: intArray() items displayed in a list box
'*************************************************************
Sub DisplayData(ByRef intArray() As Integer, ByRef lstList As ListBox)
    Dim intIndex As Integer

    For intIndex = LBound(intArray) To UBound(intArray)
        lstList.AddItem intIndex & vbTab & intArray(intIndex)
    Next intIndex
End Sub

'*************************************************************
' Sorts intArray() from low to high
'
' pre: intArray() has at least one element
' post: intArray() elements are sorted low to high
'*************************************************************
Sub InsertionSort(ByRef intArray() As Integer)
    Dim intItem As Integer, intPreviousItem As Integer
    Dim intTemp As Integer

    For intItem = LBound(intArray) + 1 To UBound(intArray)
        intTemp = intArray(intItem)
        intPreviousItem = intItem - 1
        Do While intPreviousItem > LBound(intArray) _
            And intArray(intPreviousItem) > intTemp
            intArray(intPreviousItem + 1) = intArray(intPreviousItem)
            intPreviousItem = intPreviousItem - 1
        Loop
        If intArray(intPreviousItem) > intTemp Then
            intArray(intPreviousItem + 1) = intArray(intPreviousItem)
            intArray(intPreviousItem) = intTemp
        Else
            intArray(intPreviousItem + 1) = intTemp
        End If
    Next intItem
End Sub

Private Sub cmdSearch_Click()
    Dim intNumToFind As Integer, intNumFoundIndex As Integer

    ' Get item to find
    intNumToFind = txtNumToFind.Text
    intNumFoundIndex = BinarySearch(intDataArray(), intNumToFind)
    If intNumFoundIndex = -1 Then
        lblFoundMessage.Caption = "Number not found."
    Else
        lblFoundMessage.Caption = "Number found at index " & _
        intNumFoundIndex
    End If
End Sub

Private Sub txtNumToFind_Change()
    lblFoundMessage.Caption = ""
End Sub

'****************************************************************
' Returns the index of intNumToFind if found or a -1 if not found
'
' pre: intArray() contains at least one element
' post: index of intNumToFind is returned; -1 returned if not found
'****************************************************************
Function BinarySearch(ByRef intArray() As Integer, _
ByVal intNumToFind As Integer) As Integer
    Dim intHighIndex As Integer, intMidIndex As Integer, _
    intLowIndex As Integer, blnFound As Boolean

    intHighIndex = UBound(intArray)
    intLowIndex = LBound(intArray)
    blnFound = False
    Do While Not blnFound And intLowIndex <= intHighIndex
        intMidIndex = Int((intHighIndex + intLowIndex) / 2)
        If intArray(intMidIndex) = intNumToFind Then
            blnFound = True
        ElseIf intArray(intMidIndex) > intNumToFind Then
            intHighIndex = intMidIndex - 1
        Else
            intLowIndex = intMidIndex + 1
        End If
    Loop
    If blnFound Then
        BinarySearch = intMidIndex
    Else
        BinarySearch = -1
    End If
End Function

Private Sub cmdDone_Click()
    Unload Me
End Sub

