VERSION 5.00
Begin VB.Form frmBubbleSort 
   Caption         =   "Bubble Sort"
   ClientHeight    =   2976
   ClientLeft      =   2796
   ClientTop       =   2388
   ClientWidth     =   4644
   LinkTopic       =   "Form1"
   ScaleHeight     =   2976
   ScaleWidth      =   4644
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   372
      Left            =   3360
      TabIndex        =   2
      Top             =   1920
      Width           =   1092
   End
   Begin VB.TextBox txtNumElements 
      Height          =   288
      Left            =   3840
      TabIndex        =   1
      Top             =   240
      Width           =   492
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   3360
      TabIndex        =   4
      Top             =   2400
      Width           =   1092
   End
   Begin VB.ListBox lstArrayElements 
      Height          =   2544
      ItemData        =   "frmBubbleSort.frx":0000
      Left            =   120
      List            =   "frmBubbleSort.frx":0002
      TabIndex        =   3
      Top             =   240
      Width           =   1452
   End
   Begin VB.Label lblEnterNumElements 
      Caption         =   "Enter number of elements:"
      Height          =   252
      Left            =   1800
      TabIndex        =   0
      Top             =   240
      Width           =   1932
   End
End
Attribute VB_Name = "frmBubbleSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 13 Bubble Sort
'   Chapter 13, Review 2
'   4/99

Option Explicit

Private Const intMaxNumber As Integer = 100

Private Sub Form_Load()
    Randomize
End Sub

Private Sub cmdSort_Click()
    Dim intDataArray() As Integer
    Dim intNumDataItems As Integer ' Number of items in intDataArray

    ' Create array of random numbers
    intNumDataItems = txtNumElements.Text
    Call GenerateArray(intDataArray(), intNumDataItems)

    ' Display original array in list box
    lstArrayElements.Clear
    lstArrayElements.AddItem "Original array:"  ' Title
    Call DisplayData(intDataArray(), lstArrayElements)

    ' Sort array
    Call BubbleSort(intDataArray())

    ' Display sorted array in list box
    lstArrayElements.AddItem "Sorted array:"    ' Title
    Call DisplayData(intDataArray(), lstArrayElements)
End Sub

'*******************************************************************
' Modifies intArray() to contain intNumElements random integers
' ranging from 1 to intMaxNumber
'
' pre: Randomize called
' post: intArray() contains intNumElements random integers
' ranging from 1 to intMaxNumber
'*******************************************************************
Sub GenerateArray(ByRef intArray() As Integer, _
ByVal intNumElements As Integer)
    Dim intIndex As Integer

    ReDim intArray(intNumElements - 1)

    For intIndex = LBound(intArray) To UBound(intArray)
        intArray(intIndex) = Int(intMaxNumber * Rnd + 1)
    Next intIndex
End Sub

'*********************************************************************
' Displays the contents of intArray() in a list box
'
' pre: intArray() contains at least one element
' post: intArray() items displayed in a list box
'*********************************************************************
Sub DisplayData(ByRef intArray() As Integer, ByRef lstList As ListBox)
    Dim intIndex As Integer

    For intIndex = LBound(intArray) To UBound(intArray)
        lstList.AddItem intIndex & vbTab & intArray(intIndex)
    Next intIndex
End Sub

'*******************************************************************
' Sorts intArray from low to high
'
' pre: intArray() contains at least one element
' post: intArray() elements are sorted low to high
'*******************************************************************
Sub BubbleSort(ByRef intArray() As Integer)
    Dim intItem As Integer, intIndex As Integer
    Dim blnSwapRequired As Boolean      ' Flag
    Dim intTemp As Integer

    blnSwapRequired = True
    Do While blnSwapRequired
        blnSwapRequired = False
        For intIndex = LBound(intArray) To UBound(intArray) - 1
            If intArray(intIndex) > intArray(intIndex + 1) Then
                intTemp = intArray(intIndex)
                intArray(intIndex) = intArray(intIndex + 1)
                intArray(intIndex + 1) = intTemp
                blnSwapRequired = True
            End If
        Next intIndex
    Loop
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

