VERSION 5.00
Begin VB.Form frmInsertionSort 
   Caption         =   "Insertion Sort"
   ClientHeight    =   2976
   ClientLeft      =   2448
   ClientTop       =   2388
   ClientWidth     =   4644
   LinkTopic       =   "Form1"
   ScaleHeight     =   2976
   ScaleWidth      =   4644
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   372
      Left            =   3360
      TabIndex        =   2
      Top             =   1920
      Width           =   1092
   End
   Begin VB.TextBox txtNumElements 
      Height          =   288
      Left            =   3840
      TabIndex        =   1
      Top             =   240
      Width           =   492
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   372
      Left            =   3360
      TabIndex        =   4
      Top             =   2400
      Width           =   1092
   End
   Begin VB.ListBox lstArrayElements 
      Height          =   2544
      ItemData        =   "frmInsertionSort.frx":0000
      Left            =   120
      List            =   "frmInsertionSort.frx":0002
      TabIndex        =   3
      Top             =   240
      Width           =   1452
   End
   Begin VB.Label lblEnterNumElements 
      Caption         =   "Enter number of elements:"
      Height          =   252
      Left            =   1800
      TabIndex        =   0
      Top             =   240
      Width           =   1932
   End
End
Attribute VB_Name = "frmInsertionSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Chapter 13 Insertion Sort
'   3/99

Option Explicit

Private Const intMaxNumber As Integer = 100

Private Sub Form_Load()
    Randomize
End Sub

Private Sub cmdSort_Click()
    Dim intDataArray() As Integer
    Dim intNumDataItems As Integer ' Number of items in intDataArray

    ' Create array of random numbers
    intNumDataItems = txtNumElements.Text
    Call GenerateArray(intDataArray(), intNumDataItems)

    ' Display original array in list box
    lstArrayElements.Clear
    lstArrayElements.AddItem "Original array:"      ' Title
    Call DisplayData(intDataArray(), lstArrayElements)

    ' Sort array
    Call InsertionSort(intDataArray())

    ' Display sorted array in list box
    lstArrayElements.AddItem "Sorted array:"        ' Title
    Call DisplayData(intDataArray(), lstArrayElements)
End Sub

'*******************************************************************
' Fills intArray() with intNumElements random integers ranging
' from 1 to intMaxNumber
'
' pre: Randomize called
' post: intArray() contains intNumElements random integers
' ranging from 1 to intMaxNumber
'*******************************************************************
Sub GenerateArray(ByRef intArray() As Integer, _
ByVal intNumElements As Integer)
    Dim intIndex As Integer

    ReDim intArray(intNumElements - 1)

    For intIndex = LBound(intArray) To UBound(intArray)
        intArray(intIndex) = Int(intMaxNumber * Rnd + 1)
    Next intIndex
End Sub

'******************************************************************
' Displays the contents of intArray() in a list box
'
' pre: intArray() contains at least one element
' post: intArray() items displayed in a list box
'******************************************************************
Sub DisplayData(ByRef intArray() As Integer, ByRef lstList As ListBox)
    Dim intIndex As Integer

    For intIndex = LBound(intArray) To UBound(intArray)
        lstList.AddItem intIndex & vbTab & intArray(intIndex)
    Next intIndex
End Sub

'*******************************************************************
' Sorts intArray from low to high
'
' pre: intArray() contains at least one element
' post: intArray() elements are sorted low to high
'*******************************************************************
Sub InsertionSort(ByRef intArray() As Integer)
    Dim intItem As Integer, intPreviousItem As Integer
    Dim intTemp As Integer

    For intItem = LBound(intArray) + 1 To UBound(intArray)
        intTemp = intArray(intItem)
        intPreviousItem = intItem - 1
        Do While intPreviousItem > LBound(intArray) _
            And intArray(intPreviousItem) > intTemp
            intArray(intPreviousItem + 1) = intArray(intPreviousItem)
            intPreviousItem = intPreviousItem - 1
        Loop
        If intArray(intPreviousItem) > intTemp Then
            intArray(intPreviousItem + 1) = intArray(intPreviousItem)
            intArray(intPreviousItem) = intTemp
        Else
            intArray(intPreviousItem + 1) = intTemp
        End If
    Next intItem
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

